library rzip;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  SysUtils,
  Classes,
  rzipAbbrevia_interface;

{$R *.res}

function OpenArchive(ZipFile: PChar): integer; stdcall;
begin
  Result:=rAbZipObject.OpenArchive(ZipFile);
end;

function CloseArchive(Save: boolean): integer; stdcall;
begin
  Result:=rAbZipObject.CloseArchive(Save);
end;

function GetFileList(var ListText: PChar): integer; stdcall;
var s: string;
begin
  s:=ListText;
  Result:=rAbZipObject.GetFileList(s);
  ListText:=StrAlloc(Length(s));
  StrPcopy(ListText,s);
end;

function ExtractAllFiles(OutputPath: PChar): integer; stdcall;
begin
  Result:=rAbZipObject.ExtractAllFiles(OutputPath);
end;

function ExtractFile(ExtractFile, OutputFile: PChar): integer; stdcall;
begin
  Result:=rAbZipObject.ExtractFile(ExtractFile, OutputFile);
end;

function ExtractToBuffer(ExtractFile: PChar; Buffer: Pointer; var Length: Int64): integer; stdcall;
begin
  Result:=rAbZipObject.ExtractToBuffer(ExtractFile, Buffer, Length);
end;

function ExtractContent(ExtractFile: PChar; var Content: PChar): integer; stdcall;
var s: string;
begin
  Result:=rAbZipObject.ExtractToString(ExtractFile, s);
  Content:=StrAlloc(Length(s));
  StrPcopy(Content,s);
end;

function AddFile(NewFile, InputFile: PChar): integer; stdcall;
begin
  Result:=rAbZipObject.AddFile(NewFile, InputFile);
end;

function AddFromBuffer(NewFile: PChar; Buffer: Pointer; Length: Int64): integer; stdcall;
begin
  Result:=rAbZipObject.AddFromBuffer(NewFile, Buffer, Length);
end;

function AddContent(NewFile: PChar; Content: PChar): integer; stdcall;
begin
  Result:=rAbZipObject.AddFromString(NewFile, Content);
end;

function GetLastErrorMsg: PChar; stdcall;
var s: string;
begin
  s:=rAbZipObject.GetLastErrorMsg;
  Result:=StrAlloc(Length(s));
  StrPcopy(Result,s);
end;

exports
  OpenArchive,
  CloseArchive,
  GetFileList,
  ExtractAllFiles,
  ExtractFile,
  ExtractToBuffer,
  ExtractContent,
  AddFile,
  AddContent,
  AddFromBuffer,
  GetLastErrorMsg;

begin

end.


